#! /usr/bin/perl -w
#take a clans file and add the full sequence identifier to the sequence names

if(scalar @ARGV==0){
    die "usage: perl program_name clans_file fasta_file\n";
}

open (INFILE,"<$ARGV[1]") or die "unable to open $ARGV[1]\n";
%namehash=();
while($inline=<INFILE>){
    #print STDERR $inline;
    if($inline=~/>(\S+)(.+)$/o){
	$key=$1;
	$tmpname=$2;
	chomp $tmpname;
	$tmpname=~s/[^\w\d\|\[\]\(\)-\+]+/ /g;
	$namehash{$key}=$tmpname;
    }
}
close INFILE;
print STDERR "fasta elements read:".(scalar keys %namehash)."\n";

open(INFILE,"<$ARGV[0]") or die "unable to open $ARGV[0]\n";
while($inline=<INFILE>){
    if($inline=~/>(\S+)/o){
	#$tmp=<stdin>;
	#print "read '$inline'\n";
	if(defined $namehash{$1}){
	    chomp $inline;
	    #print "in defined $1\n";
	    print $inline." ;".$namehash{$1}."\n";
	}else{
	    print $inline;
	}
    }else{
	print $inline;
    }
}
close INFILE;
